from StringIO import StringIO
import csv

from betahaus.openmember.browser.baseview import OMBaseView

class ExportBase(OMBaseView):
    """Base class for formating of export data"""
    
    def getData(self, indexes=None):
        """Get data as a list of dicts"""
        output = []
        if indexes is None:
            indexes = self.omindexes
        #FIXME: We need a standard way of querying in views
        members = self.openmember_catalog()
        fields = self.getFields()
        for member in members:
            data = []
            for field in fields:
                value = self.getFormatedField(member,field)
                data.append(value)
#                if type(data[id]) == list:
#                    subitems = []
#                    for item in data[id]:
#                        subitems
            output.append(data)
        return output
        
        

class ExportCSV(ExportBase):
    """Download data as csv"""
    
    def __call__(self):
        text = StringIO()
        writer = csv.writer(text)
        data = self.getData()
        indexes = self.omindexes
        
        #Write indexes as headers
        out = []
        for value in indexes:
            out.append(value)
        writer.writerow(out)
        
        #And write data
        for row in data:
            out = []
            for value in row:
                out.append(value)
            writer.writerow(out)
        return text.getvalue()

#        self.request.RESPONSE.setHeader('Content-Type','application/csv')
#        self.request.RESPONSE.setHeader('Content-Length',len( memberdata ))
#        self.request.RESPONSE.setHeader('Content-Disposition',
#                                        'inline;filename=open_members.csv')
    
