from zope.interface import implements
from zope.formlib import form

from plone.portlets.interfaces import IPortletDataProvider
from plone.app.portlets.portlets import base
from plone.app.portlets.cache import render_cachekey

from plone.memoize.compress import xhtml_compress

from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from Products.CMFCore.utils import getToolByName

from Products.CMFPlone import utils

from betahaus.openmember.interfaces import IOpenMemberPortlet
from betahaus.openmember import MessageFactory as _
from betahaus.openmember import OPENMEMBER_ROLE

class Assignment(base.Assignment):
    implements(IOpenMemberPortlet)

        
    @property
    def title(self):
        return _(u"OpenMember database")

class Renderer(base.Renderer):

    _template = ViewPageTemplateFile('openmember.pt')


#    @ram.cache(_render_cachekey)
    def render(self):
        return xhtml_compress(self._template())

    @property
    def available(self):
        user = getToolByName(self.context, 'portal_membership').getAuthenticatedMember()
        return user.has_role(OPENMEMBER_ROLE)
    
    @property
    def site_url(self):
        return getToolByName(self.context, 'portal_url').portal_url()
    
    @property
    def openmember_catalog(self):
        return getToolByName(self.context, 'openmember_catalog')
    
    def getFields(self):
        """Gets the fields that are to be show in the search portlet.
        """
        for index in self.openmember_catalog.indexes():
            isKeywordIndex = self.openmember_catalog.isKeywordIndex(index)
            
            if isKeywordIndex == True:
                index_type = 'selection'
                
            else:
                index_type = 'text'
                
            yield {'id': index,
                   'label': getattr(self.openmember_catalog.Indexes.get(index), 'label', index),
                   'type' : index_type,
                   }
    
    def getOptions(self, index_id):
        """
        """
        for item in self.openmember_catalog.Indexes.get(index_id).uniqueValues():
            yield item
            
    def getTitle(self, id):
        if self.openmember_catalog.isUIDLike(id):
            return self.getTitleFromUID(id)
        return id
    
            
    def getTitleFromUID(self, uid):
        """takes a uid returns a title"""
        obj = getToolByName(self.context, 'reference_catalog').lookupObject(uid)
        return obj.Title()

class AddForm(base.AddForm):
    form_fields = form.Fields(IOpenMemberPortlet)
    label = _(u"Add OpenMember portlet")
    description = _(u"")

    def create(self, data):
        return Assignment()

class EditForm(base.EditForm):
    form_fields = form.Fields(IOpenMemberPortlet)
    label = _(u"Edit OpenMember portlet")
    description = _(u"")